;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-reader.ss" "lang")((modname Hausi5_Variante2) (read-case-sensitive #t) (teachpacks ((lib "universe.rkt" "teachpack" "2htdp") (lib "image.rkt" "teachpack" "2htdp"))) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ((lib "universe.rkt" "teachpack" "2htdp") (lib "image.rkt" "teachpack" "2htdp")) #f)))
; Hausaufgabe 5, 15.11.17

;AUFGABE 1

; Length is a Number.
; interp. length of a letter in cm.

; Width is a Number.
; interp. width of a letter in cm.

; Height is a number.
; interp. height of a letter in cm.

; Weight is a Number.
; interp. weight of a letter in g.

; Format is one of:
;  - "Postkarte"
;  - "Standard"
;  - "Kompakt"
;  - "Gross"
;  - "Maxi"
; interp. the products offered by Deutsche Post
(define (which-format? format)
  (cond
    [(string=? "Standard" format) ...]
    [(string=? "Kompakt" format) ...]
    [(string=? "Gross" format) ...]
    [(string=? "Maxi" format) ...]))

; MaybeFormat is one of:
;  - Format
;  - #false
; interp. the best Format choice, or #false if no Format would work
(define (is-format? maybe-format)
  (cond
    [(string=? "Standard" maybe-format) ...]
    [(string=? "Kompakt" maybe-format) ...]
    [(string=? "Gross" maybe-format) ...]
    [(string=? "Maxi" maybe-format) ...]
    [else #false]))

;AUFGABE 2

; Length Width Height Weight -> MaybeFormat
; find the cheapest format to send something
(check-expect (cheapest-format 14 10 0.05 7) "Postkarte") 
(check-expect (cheapest-format 23.5 10 0.05 7) "Postkarte") 
(check-expect (cheapest-format 20 9 0.05 7) "Postkarte") 
(check-expect (cheapest-format 20 12.5 0.05 10) "Postkarte") 
(check-expect (cheapest-format 20 10 0 10) "Postkarte") 
(check-expect (cheapest-format 20 10 0.1 10) "Postkarte") 
(check-expect (cheapest-format 20 10 0.05 0) "Postkarte") 
(check-expect (cheapest-format 23.5 12.5 0.05 14.6875) "Postkarte") 

(check-expect (cheapest-format 14 10 0.2 10) "Standard")
(check-expect (cheapest-format 23.5 10 0.2 10) "Standard")
(check-expect (cheapest-format 20 9 0.2 10) "Standard")
(check-expect (cheapest-format 20 12.5 0.2 10) "Standard")
(check-expect (cheapest-format 20 10 0 17) "Standard")
(check-expect (cheapest-format 20 10 0.5 10) "Standard")
(check-expect (cheapest-format 20 10 0.2 0) "Standard")
(check-expect (cheapest-format 20 10 0.2 20) "Standard")

(check-expect (cheapest-format 14 12.5 0.2 10) "Gross")
(check-expect (cheapest-format 10 12.5 0.8 40) "Gross")
(check-expect (cheapest-format 14 11 0.05 14) "Gross")

(check-expect (cheapest-format 10 7 0.8 30) "Kompakt")
(check-expect (cheapest-format 23.5 10 0.8 30) "Kompakt")
(check-expect (cheapest-format 12 7 0.8 30) "Kompakt")
(check-expect (cheapest-format 20 12.5 0.8 30) "Kompakt")
(check-expect (cheapest-format 15 10 0 30) "Kompakt")
(check-expect (cheapest-format 15 10 1 30) "Kompakt")
(check-expect (cheapest-format 15 10 0.8 0) "Kompakt")
(check-expect (cheapest-format 15 10 0.8 1) "Kompakt")

(check-expect (cheapest-format 10 10 1.5 400) "Gross")
(check-expect (cheapest-format 35.3 10 1.5 400) "Gross")
(check-expect (cheapest-format 20 7 1.5 400) "Gross")
(check-expect (cheapest-format 20 25 1.5 400) "Gross")
(check-expect (cheapest-format 20 10 0 400) "Gross")
(check-expect (cheapest-format 20 10 2 400) "Gross")
(check-expect (cheapest-format 20 10 1.5 0) "Gross")
(check-expect (cheapest-format 20 10 1.5 500) "Gross")

(check-expect (cheapest-format 10 15 3 800) "Maxi")
(check-expect (cheapest-format 35.3 15 3 800) "Maxi")
(check-expect (cheapest-format 20 7 3 800) "Maxi")
(check-expect (cheapest-format 20 25 3 800) "Maxi")
(check-expect (cheapest-format 20 15 0 800) "Maxi")
(check-expect (cheapest-format 20 15 5 800) "Maxi")
(check-expect (cheapest-format 20 15 3 0) "Maxi")
(check-expect (cheapest-format 20 15 3 1000) "Maxi")
(check-expect (cheapest-format 50 30 4 800) #false)

; AUFGABE 3


(define (cheapest-format length width height weight)
  (cond
    [(format-possible? "Postkarte" length width height weight)
     "Postkarte"]
    [(format-possible? "Standard" length width height weight)
     "Standard"]
    [(format-possible? "Kompakt" length width height weight)
     "Kompakt"]
    [(format-possible? "Gross" length width height weight)
     "Gross"]
    [(format-possible? "Maxi" length width height weight)
     "Maxi"]
    [else
     #false]))



; Format Length Width Height Weight -> Boolean
; check whether we can send something as a given format
(define (format-possible? format length width height weight)
  (and (in-range? length (min-length format) (max-length format))
       (in-range? width (min-width format) (max-width format))
       (below-maximum? height (max-height format))
       (below-maximum? weight (max-weight format length width))
       (above-minimum? (aspect-ratio length width)
                       (min-aspect-ratio format))))

; Min-Ratio is a Number
; interp. the necessary length to width ratio of a Format
(define MIN-RATIO 1.4)

; Maximum is a Number.
; interp. the upper bound of something

; Minimum is a Number.
; interp. the lower bound of something

; AspectRatio is a Number.
; interp. ratio of length to width

; MaybeMinimum is one of:
;  - #false
;  - Minimum
; interp. the lower bound of something, or #false if there's no lower bound

(define (maybe-minimum-template maybe-minimum)
  (if (false? maybe-minimum) 
      ...
      (... maybe-minimum ...)))



; in-range?
;
; Number Minimum Maximum -> Boolean
; Check whether a number is between a minimum and a maximum
(check-expect (in-range? 0 0 0) #true)
(check-expect (in-range? 2 1 3) #true)
(check-expect (in-range? 1 2 3) #false)
(check-expect (in-range? 3 1 2) #false)

(define (in-range? number minimum maximum)
  (and
   [above-minimum? number minimum]
   [below-maximum? number maximum]))

; above-minimum?
;
; Number MaybeMinimum -> Boolean
; Check whether a number is above an optional minimum
(check-expect (above-minimum? 4 #false) #true)
(check-expect (above-minimum? 4 2) #true)
(check-expect (above-minimum? 2 4) #false)
(check-expect (above-minimum? 4 4) #true)

(define (above-minimum? number maybe-minimum)
  (if (false? maybe-minimum) #true (>= number maybe-minimum)))


; below-maximum?
;
; Number Maximum -> Boolean
; Check whether a number is below a maximum
(check-expect (below-maximum? 19 4) #false)
(check-expect (below-maximum? 4 19) #true)
(check-expect (below-maximum? 4 4) #true)

(define (below-maximum? number maximum)
  (<= number maximum) )

; min-length
;
; Format -> Minimum
; return minimum length of a format
(check-expect (min-length "Postkarte") 14)
(check-expect (min-length "Standard") 14)
(check-expect (min-length "Kompakt") 10)
(check-expect (min-length "Gross") 10)
(check-expect (min-length "Maxi") 10)

(define (min-length format)
  (cond
    [(string=? "Postkarte" format) 14]
    [(string=? "Standard" format) 14]
    [(string=? "Kompakt" format) 10]
    [(string=? "Gross" format) 10]
    [(string=? "Maxi" format) 10]))

; max-length
;
; Format -> Maximum
; return maximum length of a format
(check-expect (max-length "Postkarte") 23.5)
(check-expect (max-length "Standard") 23.5)
(check-expect (max-length "Kompakt") 23.5)
(check-expect (max-length "Gross") 35.3)
(check-expect (max-length "Maxi") 35.3)

(define (max-length format)
  (cond
    [(string=? "Postkarte" format) 23.5]
    [(string=? "Standard" format) 23.5]
    [(string=? "Kompakt" format) 23.5]
    [(string=? "Gross" format) 35.3]
    [(string=? "Maxi" format) 35.3]))

; min-width
;
; Format -> Minimum
; return minimum width of a format
(check-expect (min-width "Postkarte") 9)
(check-expect (min-width "Standard") 9)
(check-expect (min-width "Kompakt") 7)
(check-expect (min-width "Gross") 7)
(check-expect (min-width "Maxi") 7)

(define (min-width format)
  (cond
    [(string=? "Postkarte" format) 9]
    [(string=? "Standard" format) 9]
    [(string=? "Kompakt" format) 7]
    [(string=? "Gross" format) 7]
    [(string=? "Maxi" format) 7]))

; max-width
;
; Format -> Maximum
; return maximum width of a format
(check-expect (max-width "Postkarte") 12.5)
(check-expect (max-width "Standard") 12.5)
(check-expect (max-width "Kompakt") 12.5)
(check-expect (max-width "Gross") 25)
(check-expect (max-width "Maxi") 25)

(define (max-width format)
  (cond
    [(string=? "Postkarte" format) 12.5]
    [(string=? "Standard" format) 12.5]
    [(string=? "Kompakt" format) 12.5]
    [(string=? "Gross" format) 25]
    [(string=? "Maxi" format) 25]))

; max-height
;
; Format -> Maximum
; return maximum height of a format
(check-expect (max-height "Postkarte") 0.1)
(check-expect (max-height "Standard") 0.5)
(check-expect (max-height "Kompakt") 1)
(check-expect (max-height "Gross") 2)
(check-expect (max-height "Maxi") 5)

(define (max-height format)
  (cond
    [(string=? "Postkarte" format) 0.1]
    [(string=? "Standard" format) 0.5]
    [(string=? "Kompakt" format) 1]
    [(string=? "Gross" format) 2]
    [(string=? "Maxi" format) 5]))


; max-weight-Postkarte
;
; length width -> weight
(check-expect (max-weight-postkarte 20 10) 10)

(define (max-weight-postkarte length width)
  (/ (* 500 length width) 10000))


; max-weight
;
; Format -> Maximum
; return maximum weight of a format
(check-expect (max-weight "Postkarte" 15 10) 7.5)
(check-expect (max-weight "Standard" 15 10) 20)
(check-expect (max-weight "Kompakt" 15 10) 50)
(check-expect (max-weight "Gross" 15 10) 500)
(check-expect (max-weight "Maxi" 15 10) 1000)

(define (max-weight format length width)
  (cond
    [(string=? "Postkarte" format) (max-weight-postkarte length width)]
    [(string=? "Standard" format) 20]
    [(string=? "Kompakt" format) 50]
    [(string=? "Gross" format) 500]
    [(string=? "Maxi" format) 1000]))

; aspect-ratio
;
; Length Width -> AspectRatio
; compute aspect ratio of letter
(check-expect (aspect-ratio 10 5) 2)

(define (aspect-ratio length width)
  (/ length width))

; min-aspect-ratio
;
; Format -> MaybeMinimum
; return optional minimum aspect ratio of format
(check-expect (min-aspect-ratio "Postkarte") MIN-RATIO)
(check-expect (min-aspect-ratio "Standard") MIN-RATIO)
(check-expect (min-aspect-ratio "Kompakt") MIN-RATIO)
(check-expect (min-aspect-ratio "Gross") #false)
(check-expect (min-aspect-ratio "Maxi") #false)

(define (min-aspect-ratio format)
  (cond
    [(string=? "Postkarte" format) MIN-RATIO]
    [(string=? "Standard" format) MIN-RATIO]
    [(string=? "Kompakt" format) MIN-RATIO]
    [else #false]))

;AUFGABE 4
;4.2
;Das Format "Postkarte" wurde eingefügt. Dafür musste folgendes geändert werden:
;- "Postkarte" wurde in die cheapest-format-Funktion eingefügt
;- "Postkarte" wurde in die Datendefinition von Format einfgefügt
;- "Postkarte" wurde in insg. 7 Hilfsfunktionen eingefügt, die Daten vom Typ Format als Parameter erhalten
;- Zu jeder geänderten Funktion wurden auch die Tests ergänzt
;- Die Funktionen-Templates aus Aufgabe 1 wurden nicht geändert, da nur gefordert war, die Funktionen aus Aufgabe 3 zu ändern
;
;Die Änderung erforderte zwar mäßigen "Fleißaufwand", dafür aber kaum "Denkaufwand", da einfach in jeder Funktion in der
;Signatur überprüft werden konnte, ob sie den Typ Format als Eingabe verwendet. Die vorgegebene Organisation hat den Aufwand
;verringert, weil die komplizierteste Funktion format-possible gar nicht verändert werden musste.
;
;4.3
;a) Erfordert kaum Aufwand. Es muss nur ein Wert in der Funktion max-weight und im zugehörigen Test geändert werden.
;b) Erfordert kaum Aufwand, es müssen nur die Zeilen von Standard und Kompakt vertauscht werden
;c) Erfordert mehr Aufwand als das Hinzufügen vom Format "Postkarte", da zusätzlich zum neuen Format auch die Tests für die Formate
;   "Kompakt" und "Gross"  unter Umständen geändert werden müssen.
;
;4.4
;Man könnte die einzelnen Formate als Strukturen definieren, dann muss beim Hinzufügen eines neuen Formats, wie z. B. "Medium",
;nicht jede Unterfunktion geändert werden. In diese Struktur könnte man auch den Preis eines Formats integrieren.
;Auch das Gewicht könnte man so einfach ändern. So wären alle 3 Forderungen aus 4.3 erfüllt.
